<?php

namespace App\Http\Controllers;

use App\Models;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class ActionBarController extends Controller
{
    public function AddActionBar(Request $request)
    {
        $params = [];
        $params["owner_id"] = $request->input("owner_id");
        $params["parent"] = $request->input("parent");
        $params["level"] = $request->input("level");
        $params["icon"] = $request->input("icon");
        $params["link_type"] = $request->input("link_type");
        $params["link"] = $request->input("link");

        $bar = new Models\ActionBar();
        $result = $bar->AddActionBar($params);
        if ($result != "success") {
            Log::debug($result);
        }
        return $result;
    }

    public function ModifyActionBar(Request $request)
    {
        $params = [];
        $params["id"] = $request->input("id");
        $params["owner_id"] = $request->input("owner_id");
        $params["parent"] = $request->input("parent");
        $params["level"] = $request->input("level");
        $params["icon"] = $request->input("icon");
        $params["link_type"] = $request->input("link_type");
        $params["link"] = $request->input("link");
        $params["name"] = $request->input("name");
        $params["description"] = $request->input("description");

        $bar = new Models\ActionBar();
        $result = $bar->ModifyActionBar($params);
        return $result;
    }

    public function DeleteActionBar(Request $request)
    {
        $params = [];
        $bid = $request->input("id");
        $params["id"] = $bid;

        $bar = new Models\ActionBar();
        $result = $bar->DeleteActionBar($params);
        return $result;
    }

    public function LoadActionBar(Request $request)
    {
        $params = [];
        $uid = $request->input("uid");
        $params["uid"] = $uid;

        $bar = new Models\ActionBar();
        $result = $bar->ListActionBar($params);
        return "success";
    }
}


// 这个class的方法需要在中间件里加上权限判断，管理员才能执行
class UserActionBar extends Controller
{
    public function AddUserActionBar(Request $request)
    {
        $uid = $request->input("uid");
        $barId = $request->input("barId");

        $userActionBar = new Models\UserActionBar();
        $userActionBar->AddUserActionBar($uid, $barId);
        return "success";
    }

    public function RemoveActionBar(Request $request)
    {
        $uid = $request->input("uid");
        $barId = $request->input("barId");

        $userActionBar = new Models\UserActionBar();
        $userActionBar->RemoveUserActionBar($uid, $barId);
        return "success";
    }
}
